(function ($) {
    'use strict';
    $.fn.execCommand = function(command) {
        document.execCommand(command, false, null);
    };
    $.fn.getHtml = function() {
        if (typeof Host !== "undefined") {
             Host.setHtml(this.attr('id'), this.html());
        }
    };
    $.fn.callAutoSaveBody = function() {
            if (typeof Host != "undefined") {
                var body = "undefined";         //  DON'T change
                var quoted = "undefined";       //  DON'T change

                if ($('#composer').val() !==  undefined) {
                    body = $('#composer').html();
                }
                if ($('#quoted_body').val() !== undefined) {
                    quoted = $('#quoted_body').html();
                }

                Host.updateComposeBody(body, quoted);
            }
        }
    $.fn.getComposerBody = function() {
        if (typeof Host != "undefined") {
            var body = "undefined";         //  DON'T change
            var quoted = "undefined";       //  DON'T change

            if ($('#composer').val() !==  undefined) {
                body = $('#composer').html();
            }
            if ($('#quoted_body').val() !== undefined) {
                quoted = $('#quoted_body').html();
            }

            Host.setComposerBody(body, quoted);
        }
    }
    $.fn.signature = function(enable, body) {
        var signature = $('#signature-x')[0];
        
        if (signature !== undefined) {
            if (enable == "true") {
                signature.innerHTML=$('<div/>').html(body).text();
                signature.style.display="";
            } else {
                signature.style.display="none";
            }
        }
    };
        
    $.fn.initComposerObserver = function() {
        $("#composer").bind("DOMSubtreeModified", function() {
            if (typeof Host !== "undefined") {
                Host.observerCallback('composer');
            }
        });

        //  MutationObserver doesn't run on JB or lower.
//        var target = document.querySelector('#composer');
//        MutationObserver = window.MutationObserver || window.WebKitMutationObserver;
//        var observer = new MutationObserver(function(mutations) {
//            mutations.forEach(function(mutation) {
//                console.log(mutation.type);
//            })
//        })
//        var config = { attributes: true, childList: true, characterData: true };
//        observer.observe(target, config);
    };
    $.fn.initQuotedBodyObserver = function() {
        $("#quoted_body").bind("DOMSubtreeModified", function() {
            if (typeof Host !== "undefined") {
                Host.observerCallback('quoted_body');
            }
        });
    };
    $.fn.moveCaret = function() {
        var range = document.createRange();
        range.selectNodeContents(composer);
        range.collapse(false);

        var selection = window.getSelection();
        selection.removeAllRanges();
        selection.addRange(range);
    };
    
    $.fn.enableEditable = function() {
        this.attr('contenteditable', true);
    };
    
    $.fn.autoSave = function () {
        this.on('keyup', function () {
            if (typeof Host !== "undefined") {
                Host.autoSave();
            }
        });
    }
    $.fn.focusEnd = function () {
        var children = $(this).children();
        var child = children.get(0);
        if (child) {
            if (child.textContent.length == 0 &&
                children.length == 2) {
                //  It means that it is empty(or initial) body.
                //  it doesn't need to move cursor to the end.
                return this;
            }
        }

        $(this).focus();
        var tmp = $('<span />').appendTo($(this)),
            node = tmp.get(0),
            range = null,
            sel = null;

        range = document.createRange();
        range.selectNode(node);
        sel = window.getSelection();
        sel.removeAllRanges();
        sel.addRange(range);

        tmp.remove();
        return this;
    }
    
    $.fn.initialize = function () {
        var composer = this,
            selectedRange,
            updateToolbar = function () {
                var commands = [
                    'undo',
                    'redo',
                    'bold',
                    'italic',
                    'underline',
                    //'fontSize',
                    //'foreColor',
                    //'backColor'
                ];
                commands.forEach(function(command, index, array) {
                    var enabled = false;
                    if (document.queryCommandState(command)) {
                        enabled = true;
                    }
                    if (typeof Host === "undefined") {
//                        console.log("'" + command + "' is " + enabled);
                    } else {
                        Host.updateToolbar(command, enabled);
                    }
                });
            },
            updateCaretPos = function() {
                var top = 0, bottom = 0;
                var sel = window.getSelection();
                var extendOffset = 0;

                if (sel.baseNode == null)
                    return;

                if (sel.baseNode.nodeType == Node.ELEMENT_NODE) {
                    top = sel.extentNode.offsetTop;
                    bottom = sel.extentNode.offsetTop + sel.extentNode.clientHeight;
                } else {
                    var range = sel.getRangeAt(0);
                    if (range.getClientRects) {
                        var rects = range.getClientRects();
                        if (rects.length > 0) {
                            top = rects[0].top;
                            bottom = rects[0].bottom;
                        }
                        
                        extendOffset = sel.extentOffset;
                    }
                }
                Host.updateCaretPos($('#composer')[0].offsetTop + extendOffset, top, bottom);
            }
            composer.attr('contenteditable', true)
                .on('keyup', function () {
                    updateCaretPos();
                }).on('mouseup mouseout', function () {
                  updateToolbar();
               });
    };
}(window.jQuery));
