var JSDecryptor = {
    code: [],
    index: 0,
    jsState: false,
    logLevel: false,
    key: false,
    pushCode: function (encryptedCode) {
        this.code.push(encryptedCode);
    },
    init: function (hexKey, jsState, logLevelName) {
        JSDecryptor.log("JSDecryptor.init()");
        this.jsState = jsState;
        this.logLevel = logLevelName;
        JSDecryptor.decrypt(hexKey);
    },
    decrypt: function (hexKey) {
        JSDecryptor.log("JSDecryptor.decrypt()");
        if (!this.key && hexKey && hexKey.length > 0) {
             this.key = CryptoJS.enc.Hex.parse(hexKey);
        }
        
        if (this.key) {
            if (this.index < this.code.length) {
                JSDecryptor.log("Decrypting code: " + this.index);
                var iv = CryptoJS.enc.Base64.parse(this.code[this.index].iv);
                var fileKey = this.key.clone();
                fileKey.concat(iv);
                // Need to break up the UTF-8 conversion of words into smaller chunks so BlackBerry 0S 5.0 will work.
                var plain = "";
                var plainWords = CryptoJS.RC4Drop.decrypt(this.code[this.index].ct, fileKey, {drop: 64});
                JSDecryptor.log("Number of words to decode: " + plainWords.words.length);
                var INCREMENT = 5000;
                while (plainWords.words.length > 0) {
                    JSDecryptor.log("Number of words left to decode: " + plainWords.words.length);
                    var tempWords = plainWords.words.splice(0, INCREMENT);
                    var tempSigBytes = plainWords.sigBytes;
                    if (tempWords.length == INCREMENT) {
                        tempSigBytes = INCREMENT * 4;
                        plainWords.sigBytes -= tempSigBytes;
                    }
                    plain += CryptoJS.lib.WordArray.create(tempWords, tempSigBytes).toString(CryptoJS.enc.Utf8);
                }
                var el = document.createElement('script');
                el.appendChild(document.createTextNode(plain));
                document.body.appendChild(el);
                this.code[this.index] = false;
                JSDecryptor.log("Decrypting code complete: " + this.index);
                this.index++;
                setTimeout("JSDecryptor.decrypt()", 1);
            } else {
                JSDecryptor.log("Decryption complete.");
                setTimeout("JSDecryptor.decryptComplete()", 1);
            }
        } else {
            JSDecryptor.log("No key found. Decryption complete.");
            setTimeout("JSDecryptor.decryptComplete()", 1);
        }
    },
    decryptComplete: function() {
        JSDecryptor.log("JSDecryptor.decryptComplete()");
        this.code = []; // reset
        this.index = 0;
        this.key = false;
        if (this.logLevel) {
            JSDecryptor.log("JSDecryptor.decryptComplete() calling setLogLevel");
            SCUtils.setLogLevelByName(this.logLevel);
            this.logLevel = false;
        }
        if (EntrustSC.nativeImpl && EntrustSC.nativeImpl.decryptComplete) {
            EntrustSC.nativeImpl.decryptComplete();
        }
        if (this.jsState) {
            JSDecryptor.log("JSDecryptor.decryptComplete() calling loadState");
            EntrustSC.loadState(this.jsState);
            this.jsState = false;
        }
    },
    log: function(message) {
        try {
            console.log(message);
        } catch (e) {}
    }
};
